"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = validate;

function _sliceIterator(arr, i) { var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _slicedToArray(arr, i) { if (Array.isArray(arr)) { return arr; } else if (Symbol.iterator in Object(arr)) { return _sliceIterator(arr, i); } else { throw new TypeError("Invalid attempt to destructure non-iterable instance"); } }

var _require = require("../AST/traverse"),
    traverse = _require.traverse;

var _require2 = require("./type-inference"),
    getType = _require2.getType;

function validate(ast) {
  var errors = [];
  traverse(ast, {
    Func: function (_Func) {
      function Func(_x) {
        return _Func.apply(this, arguments);
      }

      Func.toString = function () {
        return _Func.toString();
      };

      return Func;
    }(function (_ref) {
      var node = _ref.node;

      // Since only one return is allowed at the moment, we don't need to check
      var _node$result = _slicedToArray(node.result, 1),
          resultType = _node$result[0]; // Function has no result types or last instruction, we can skip it


      if (typeof resultType !== "string") {
        return;
      }

      var lastInstructionResultType = getType(node.body); // Type is unknown, we can not verify the result type

      if (!lastInstructionResultType) {
        return;
      }

      if (resultType !== lastInstructionResultType) {
        var name = "anonymous";

        if (node.name != null) {
          name = node.name.value;
        }

        errors.push("- function '".concat(name, "' expected result type ").concat(resultType, ",") + " but ".concat(lastInstructionResultType, " given."));
        return;
      }
    })
  });
  return errors;
}